/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ALNS_Insercoes;

import Principal.Instancia;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */

public class InsercaoArrependimento extends Insercoes{
    
    public int getIndice(){
        return 1;
    }
    
    public Solucao execute(Solucao sol, Instancia instancia, ArrayList<Integer> conjQ, Random rand){
        
        //1ªmelhor posição
        ArrayList<Integer> posicao1 = new ArrayList<Integer>();
        //Máquina da 1ª melhor posição
        ArrayList<Integer> maquina1 = new ArrayList<Integer>();
        //Custo da 1ª e 2ª melhor posição
        ArrayList<Double> custo1 = new ArrayList<Double>();
        ArrayList<Double> custo2 = new ArrayList<Double>();
        
        ArrayList<Double> arrependimento = new ArrayList<Double>();
        ArrayList<Integer> conjJobs = new ArrayList<Integer>();
        
        //Percorrendo conjunto Q
        for(int y=0; y<conjQ.size(); y++){
            
            //Tarefa que está sendo analizada
            int tarefaAtual = conjQ.get(y);
            
            //Iniciando listas
            posicao1.add(-1);
            maquina1.add(-1);
            arrependimento.add(-1.0);
            conjJobs.add(tarefaAtual);
            custo1.add(Double.MAX_VALUE);
            custo2.add(Double.MAX_VALUE);
            
            //Percorrendo as máquinas
            for(int i=0; i<instancia.getNumMaqs(); i++){
                
                //Se a máquina estiver vazia
                if(sol.getSol().get(i).isEmpty()){
                    
                    double custoInserir = sol.regraDelta_Inserir2(instancia, i, tarefaAtual, 0);
                    int posicaoInserir = 0;
                    
                    //Armazenado o 1º melhor custo
                    if(custo1.get(y) > custoInserir){
                        custo1.set(y, custoInserir);
                        posicao1.set(y, posicaoInserir);
                        maquina1.set(y, i);
                    }
                    //Armazenando o 2º melhor custo
                    else if(custo2.get(y) > custoInserir){
                        custo2.set(y, custoInserir);
                    }
                }
                else{
                
                    //Percorrendo as posições
                    for(int j=0; j<sol.getSol().get(i).size()+1; j++){

                        //Custo de inserir a tarefa: custo de inserção
                        double custoInserir = 0;
                        int posicaoInserir = -1;
                        if(j == sol.getSol().get(i).size()){
                            custoInserir = sol.getCustoMaq().get(i) + sol.regraDelta_Inserir2(instancia, i, tarefaAtual, j-1);
                            posicaoInserir = j-1;
                        }
                        else{
                            custoInserir = sol.getCustoMaq().get(i) + sol.regraDelta_Inserir2(instancia, i, tarefaAtual, j);
                            posicaoInserir = j;
                        }

                        //Armazenado o 1º melhor custo
                        if(custo1.get(y) > custoInserir){
                            custo1.set(y, custoInserir);
                            posicao1.set(y, posicaoInserir);
                            maquina1.set(y, i);
                        }
                        //Armazenando o 2º melhor custo
                        else if(custo2.get(y) > custoInserir){
                            custo2.set(y, custoInserir);
                        }
                    }
                }

                
            }
        }
        
        //Calculando o arrependimento
        for(int y=0; y<conjQ.size(); y++)
            arrependimento.set(y,custo2.get(y) - custo1.get(y));
        
        //System.out.println("Vetor de custo 1ª: " + custo1);
        //System.out.println("Vetor de custo 2ª: " + custo2);
        //System.out.println("Arrependimento: " + arrependimento);
        //System.out.println("Tarefas: " + conjJobs);
        //System.out.println("Conjunto Q: " + conjQ);
        
        //Insere as tarefas de maior arrependimento no 1º menor custo
        int auxiliar = conjQ.size();
        for(int y=0; y<auxiliar; y++){
        
            //Pegando maior arrependimento
            double maiorArrep = Collections.max(arrependimento);
            int auxPosicao_Tarefa = arrependimento.indexOf(maiorArrep); //Índice o maior arrependimento
            
            //Pegando dados para inserção
            int tarefa = conjQ.get(auxPosicao_Tarefa);
            int posicao = posicao1.get(auxPosicao_Tarefa);
            int maquina = maquina1.get(auxPosicao_Tarefa);
            
            //System.out.println(posicao1);
            //System.out.println("Tarefa: " + tarefa +  " - custo: " + maiorArrep + " - Posicao: " + posicao);
            
            //Inserindo no 1º menor custo
            if(posicao == sol.getSol().get(maquina).size()) //última posição
                sol.getSol().get(maquina).add(tarefa);
            else
                sol.getSol().get(maquina).add(posicao, tarefa);
            
            //Atualizando o Custo
            double custo = sol.regraDelta_Inserir2(instancia, maquina, tarefa, posicao);
            sol.getCustoMaq().set(maquina, (sol.getCustoMaq().get(maquina) + custo));
        
            //Removendo tarefa da lista de arrependimento
            arrependimento.remove(auxPosicao_Tarefa);
            conjQ.remove(auxPosicao_Tarefa);
            
            //System.out.println(arrependimento);
        }
        
        return sol;
    }
    
}
