/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ALNS_Insercoes;

import Principal.Instancia;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */

//Funcionamento idêntico ao construtor guloso CP_ASPT
public class InsercaoGuloso extends Insercoes{
    
    public int getIndice(){
        return 2;
    }
    
    
    public Solucao execute(Solucao sol, Instancia instancia, ArrayList<Integer> conjQ, Random rand){
        
        //Embaralhando conjQ
        Collections.shuffle(conjQ);
        
        while(conjQ.size() > 0){
        
            //Declarando Listas
            ArrayList<Double> conjCusto = new ArrayList<Double>(); //Custo da alocação
            ArrayList<Integer> conjMaquinas = new ArrayList<Integer>(); //Máquina para alocação
            ArrayList<Integer> conjPosicoes = new ArrayList<Integer>(); //Posição para posições
        
            //Calculando o custo em todas as posições de todas as máquinas
            for(int q=0; q<conjQ.size(); q++){
            
                //Valor inicial!
                conjCusto.add(q,Double.MAX_VALUE);
                conjMaquinas.add(q,-1);
                conjPosicoes.add(q,-1);

                //Percorrendo as posições de todas as máquinas
                for(int j=0; j<instancia.getNumMaqs();j++){
                    for(int i=0; i<=sol.getSol().get(j).size();i++){

                        //1º - Custo de Inserção: passando como parâmentros -> instância, máquina, tarefa, e a posição da tarefa
                        double custoInsercao = sol.regraDelta_Inserir2(instancia, j, conjQ.get(q), i);

                        //2º - Custo da máquina: custo de inserção + custo atual da máquina
                        double custoAcumulado = custoInsercao + sol.getCustoMaq().get(j);
                        
                        //Armazenando o menor custo para cada tarefa do conjQ
                        if(conjCusto.get(q) > custoAcumulado){
                            conjCusto.set(q, custoAcumulado);
                            conjMaquinas.set(q, j);
                            conjPosicoes.set(q, i);
                        }
                    }
                }
            }
            
            //System.out.println(conjCusto);
            //System.out.println(conjMaquinas);
            //System.out.println(conjPosicoes);
            
            //Pegando a tarefa Q que produz o menor custo
            int indice = conjCusto.indexOf(Collections.min(conjCusto));
            int tarEscolhida = conjQ.get(indice);
            int maqEscolhida = conjMaquinas.get(indice);
            int posEscolhida = conjPosicoes.get(indice);
            
            //System.out.println(tarEscolhida);
            
            //Removendo a tarefa do conjQ e suas informações
            conjQ.remove(indice);
            conjCusto.remove(indice); //Remove o custo
            conjMaquinas.remove(indice); //Remove a máquina
            conjPosicoes.remove(indice); //Remove a posição
            
            //Adicionar Tarefa a Solução
            sol.getSol().get(maqEscolhida).add(posEscolhida,tarEscolhida);
            
            //Atualizando o custo de inserção
            double custoI = sol.regraDelta_Inserir2(instancia, maqEscolhida, tarEscolhida, posEscolhida);
            sol.getCustoMaq().set(maqEscolhida, (sol.getCustoMaq().get(maqEscolhida) + custoI));
            
        }
        
        return sol;
    }
    
}
