/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ALNS_Insercoes;

import Heuristicas.MetodoHungaro;
import Principal.Instancia;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */

//Inserção usando o método Húngaro
public class InsercaoHungaro extends Insercoes {
    
    public int getIndice(){
        return 3;
    }
    
    public Solucao execute(Solucao sol, Instancia instancia, ArrayList<Integer> conjQ, Random rand){
        
        //Embaralhando conjQ
        Collections.shuffle(conjQ);
        
        //System.out.println(conjQ);
        
        //Total de execuções a serem realizadas pelo método Húngaro 
        double totalExec = 0;
        if(instancia.getNumMaqs() == conjQ.size()){
            totalExec = 1; //Tamanho ideal para uma execução do método Húngaro
        }
        else if(instancia.getNumMaqs() > conjQ.size()){
            totalExec = 0; //Não dá para usar o algoritmo Húngaro
            //sorteia Q máquinas ******************** -> ainda não realizado
        }
        else{
            totalExec = conjQ.size() / instancia.getNumMaqs(); //a cada iteração ele aloca uma tarefa para cada máquina
        }
        
        //Iterações de execução Método Húngaro 
        int iter_conjQ = 0;
        for(int w=0; w<totalExec; w++){
            
            //Parte do conjQ que será inserida usando o método Húngaro
            ArrayList<Integer> parte_conjQ = new ArrayList<Integer>();
            //System.out.println("Conjunto: " + conjQ);
            for(int j=0; j<instancia.getNumMaqs(); j++)
                parte_conjQ.add(conjQ.get(iter_conjQ++));
            
            //Montar matriz de custos
            double Mc[][] = new double[instancia.getNumMaqs()][instancia.getNumMaqs()];
        
            //Matriz de Posições
            int MatPos[][] = new int[instancia.getNumMaqs()][instancia.getNumMaqs()];
            
            //Percorrendo as tarefas da lista
            for (int a=0; a<parte_conjQ.size(); a++){

                //Tarefa atual
                int tarefaAtual = parte_conjQ.get(a);

                //Percorrendo todas as posições de todas as máquinas
                for(int i=0; i<instancia.getNumMaqs(); i++){

                    //Custo da máquina i
                    double custoMaqMax = Integer.MAX_VALUE;

                    //Label para última posição
                    boolean ultimaPosicao = false;
                    int posicaoEscolhida; //Posição momentanea
                    int melhorPosicao = -1; //Melhor posição

                    //Percorrendo todas as posições da máquina i
                    for(int j=0; j<sol.getSol().get(i).size()+1; j++){

                        //Sol Fictícia
                        Solucao sol2 = new Solucao(instancia);
                        sol2.clonarSolucoes(sol);

                        //Última Posição
                        if(j == (sol2.getSol().get(i).size()) ){ //Último item
                            sol2.getSol().get(i).add(tarefaAtual);
                            ultimaPosicao = true;
                        }
                        //Posição Intermediária
                        else {
                            ultimaPosicao = false;
                            sol2.getSol().get(i).add(j, tarefaAtual);
                        }

                        //Atualizando a Posição Escolhida
                        if(!ultimaPosicao)
                           posicaoEscolhida = j;
                        else
                           posicaoEscolhida = sol2.getSol().get(i).size()-1;

                        //Custo - Inserindo a Tarefa
                        double custoInserir = sol2.regraDelta_Inserir2(instancia, i, tarefaAtual, posicaoEscolhida);
                        sol2.getCustoMaq().set(i, (sol2.getCustoMaq().get(i) + custoInserir));

                        if(sol2.getCustoMaq().get(i) < custoMaqMax){
                            custoMaqMax = sol2.getCustoMaq().get(i);
                            melhorPosicao = posicaoEscolhida;
                        }
                    }

                    //Armazenando as posições de menor custo
                    Mc[i][a] = custoMaqMax;
                    MatPos[i][a] = melhorPosicao;
                    
                }
            }
            
            //NOVO: O método Húngaro só trabalha com valores inteiros
            for(int z=0; z<instancia.getNumMaqs(); z++){
                for(int p=0; p<instancia.getNumMaqs(); p++){
                    Mc[z][p] = (int) Mc[z][p];
                    //System.out.printf(Mc[z][p] + " ");
                }
                //System.out.println();
            }
            
            //Chamar método húngaro
            MetodoHungaro hung = new MetodoHungaro();
            int []alocOtima = new int[instancia.getNumMaqs()];
            alocOtima = hung.hungarian(instancia.getNumMaqs(), Mc, alocOtima);
            
            //NOVO:
            //for(int z=0; z<instancia.getNumMaqs(); z++){
            //    System.out.printf(alocOtima[z] + " ");
            //}
            //System.out.println();
            
            //Montar a nova solução
            boolean ultimaPosicao = false;
            int posicaoEscolhida;

            for(int i=0; i<instancia.getNumMaqs(); i++){

                //Posição Ótima
                int maqAlocada = alocOtima[i];
                int posAlocada = MatPos[maqAlocada][i];

                //Ultima posição
                if(posAlocada == (sol.getSol().get(maqAlocada).size()) ){ //Último item
                    sol.getSol().get(maqAlocada).add(parte_conjQ.get(i));
                    ultimaPosicao = true;
                }
                //Posição Intermediária
                else {
                    ultimaPosicao = false;
                    sol.getSol().get(maqAlocada).add(posAlocada, parte_conjQ.get(i));
                }

                //Atualizando a Posição Escolhida
                if(!ultimaPosicao)
                   posicaoEscolhida = posAlocada;
                else
                   posicaoEscolhida = sol.getSol().get(maqAlocada).size()-1;

                //Custo - Inserindo a Tarefa
                double custoInserir = sol.regraDelta_Inserir2(instancia, maqAlocada, parte_conjQ.get(i), posicaoEscolhida);
                sol.getCustoMaq().set(maqAlocada, (sol.getCustoMaq().get(maqAlocada) + custoInserir));
                
            }
        }    
           
        //Ainda não alocou totas as tarefas
        if(conjQ.size() > iter_conjQ){
            
            //A parte final do conjQ será alocada usando o método InsercaoGuloso
            ArrayList<Integer> parte_conjQ = new ArrayList<Integer>();
            int auxiliar = iter_conjQ;
            for(int j=auxiliar; j<conjQ.size(); j++)
                parte_conjQ.add(conjQ.get(iter_conjQ++));
            
            //Executando o método InsercaoGuloso
            InsercaoGuloso insercaoGuloso = new InsercaoGuloso();
            sol = insercaoGuloso.execute(sol, instancia, parte_conjQ, rand);
        }
        
        return sol;
    }
    
}
