/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ALNS_Insercoes;

import Heuristicas.CG_ASPT;
import Principal.Instancia;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */

//Funcionamento idêntico ao construtor parcialmente guloso CPG_ASPT
public class InsercaoSemiGuloso extends Insercoes{
    
    public int getIndice(){
        return 5;
    }
    
    
    public Solucao execute(Solucao sol, Instancia instancia, ArrayList<Integer> conjQ, Random rand){
        
        //Embaralhando conjQ
        Collections.shuffle(conjQ);
        
        double alfa = 0.2;
        
        while(conjQ.size() > 0){
        
            //Declarando Listas
            ArrayList<Double> conjCusto = new ArrayList<Double>(); //Custo da alocação
            ArrayList<Integer> conjMaquinas = new ArrayList<Integer>(); //Máquina para alocação
            ArrayList<Integer> conjPosicoes = new ArrayList<Integer>(); //Posição para posições
        
            //Calculando o custo em todas as posições de todas as máquinas
            for(int q=0; q<conjQ.size(); q++){
            
                //Valor inicial!
                conjCusto.add(q,Double.MAX_VALUE);
                conjMaquinas.add(q,-1);
                conjPosicoes.add(q,-1);

                //Percorrendo as posições de todas as máquinas
                for(int j=0; j<instancia.getNumMaqs();j++){
                    for(int i=0; i<=sol.getSol().get(j).size();i++){

                        //1º - Custo de Inserção: passando como parâmentros -> instância, máquina, tarefa, e a posição da tarefa
                        double custoInsercao = sol.regraDelta_Inserir2(instancia, j, conjQ.get(q), i);

                        //2º - Custo da máquina: custo de inserção + custo atual da máquina
                        double custoAcumulado = custoInsercao + sol.getCustoMaq().get(j);
                        
                        //Armazenando o menor custo para cada tarefa do conjQ
                        if(conjCusto.get(q) > custoAcumulado){
                            conjCusto.set(q, custoAcumulado);
                            conjMaquinas.set(q, j);
                            conjPosicoes.set(q, i);
                        }
                    }
                }
            }
            
            //System.out.println(conjCusto);
            //System.out.println(conjMaquinas);
            //System.out.println(conjPosicoes);
            
            //Calculando o valor aceitável dentro da variação
            double maiorCusto = Collections.max(conjCusto); //Alocação de maior custo
            double menorCusto = Collections.min(conjCusto); //Alocação de menor custo
            double custoVariacao = (maiorCusto - menorCusto) * alfa; // Variação entre os custos vezes o alfa
            double valorAceitavel = menorCusto + custoVariacao; //Valor máximo aceitável para inserção 
            
            //System.out.println("custoVariação: " + custoVariacao + " | valorAceitável: " + valorAceitavel);
            
            //Pegando um custo aleatório dentro do valor aceitável
            int indice = rand.nextInt(conjCusto.size());
            double valorCusto = conjCusto.get(indice);
            int contador = 0; //máximo de iterações: tamanho de conjunto
            while( (valorCusto >= valorAceitavel) && (contador < conjCusto.size())){
                indice = rand.nextInt(conjCusto.size());
                valorCusto = conjCusto.get(indice);
                contador++;
            }
            //Caso não encontre um valor dentro do aceitável, pegue o menor valor
            if(contador >= conjCusto.size()){
                indice = conjCusto.indexOf(Collections.min(conjCusto));
            }
            
            //Armazenando os dados da alocação
            int tarEscolhida = conjQ.get(indice);
            int maqEscolhida = conjMaquinas.get(indice);
            int posEscolhida = conjPosicoes.get(indice);
            
            //System.out.println(tarEscolhida);
            
            //Removendo a tarefa do conjQ e suas informações
            conjQ.remove(indice);
            conjCusto.remove(indice); //Remove o custo
            conjMaquinas.remove(indice); //Remove a máquina
            conjPosicoes.remove(indice); //Remove a posição
            
            //Adicionar Tarefa a Solução
            sol.getSol().get(maqEscolhida).add(posEscolhida,tarEscolhida);
            
            //Atualizando o custo de inserção
            double custoI = sol.regraDelta_Inserir2(instancia, maqEscolhida, tarEscolhida, posEscolhida);
            sol.getCustoMaq().set(maqEscolhida, (sol.getCustoMaq().get(maqEscolhida) + custoI));
            
        }
        
        return sol;
        
        //Enquanto existirem tarefas não alocadas
        /*while(conjQ.size() > 0){
            
            //Definindo o Custo Acumulado
            double [][]custoAc = new double[instancia.getNumJobs()+1][instancia.getNumMaqs()+1];
            for(int i=0; i<conjQ.size();i++){
                for(int j=0; j<instancia.getNumMaqs();j++){
                    int job = conjQ.get(i); //Pegando uma Tarefa
                    custoAc[job][j] = CG_ASPT.defineCustoAcu(instancia, job, j, sol); //Quanto menor a pontuação, menor é o tempo acumulado com a inserção da tarefa
                }
            }
            
            //Analisando os Custos
            double maiorValor=0, menorValor=Double.MAX_VALUE;
            for(int i=0; i<conjQ.size();i++){
                for(int j=0; j<instancia.getNumMaqs();j++){
                   int job = conjQ.get(i); //Pegando uma Tarefa
                   if(custoAc[job][j] > 0){  //Desprezar o custo 0, pois são as tarefas já alocadas                   
                      if(custoAc[job][j] > maiorValor)
                         maiorValor = custoAc[job][j];
                      if(custoAc[job][j] < menorValor)
                         menorValor = custoAc[job][j];
                   }     
               }     
            }
            
            //System.out.println("gmin:" + menorValor + " gmax:" + maiorValor);
            
            //Calculando a Variacao
            double variacaoInt = maiorValor - menorValor;
            if(variacaoInt == 0) //Se a varicao for 0 - Caso onde não há diferença de tempo
               variacaoInt = 1;
            double variacaoDoub = variacaoInt * alfa;
            
            //Escolhendo de Forma Randomica a Alocacao que obedece a Variação
            int randomicoMaquina, randomicoTarefa; int maquinaEscolhida = -1; int tarefaEscolhida = -1;
            while(maquinaEscolhida == -1){

               randomicoMaquina = rand.nextInt(instancia.getNumMaqs()); //Pega uma máquina randomicamente
               int i = rand.nextInt(conjQ.size()); //Pega uma tarefa randomicamente
               randomicoTarefa = conjQ.get(i);
               
               //Avalia se esta maquina obedece a variação
               if( (custoAc[randomicoTarefa][randomicoMaquina] != 0) && (custoAc[randomicoTarefa][randomicoMaquina] < (menorValor + variacaoDoub)) ){
                  maquinaEscolhida = randomicoMaquina;
                  tarefaEscolhida = randomicoTarefa;
               }
            }
            
            //double aux = custoAc[tarefaEscolhida][maquinaEscolhida];
            //System.out.println("g: " + aux);
            
            //Adicionar Tarefa a Solução
            sol.getSol().get(maquinaEscolhida).add(tarefaEscolhida);
            
            //Atualizando o Custo: Posição de inserir é no final da máquina
            double custoI = sol.regraDelta_Inserir2(instancia, maquinaEscolhida, tarefaEscolhida, sol.getSol().get(maquinaEscolhida).size()-1);
            sol.getCustoMaq().set(maquinaEscolhida, (sol.getCustoMaq().get(maquinaEscolhida) + custoI));
            
            //Retirar Tarefa do conjunto de tarefas não alocadas
            for(int i=0; i<conjQ.size();i++){
                int job = conjQ.get(i); //Pegando uma Tarefa
                if(job == tarefaEscolhida){
                    conjQ.remove(i);
                }
            }

        }
        
        //Define o custo para as máquinas
        //sol.definirCustoMaqs();
        
        return sol;
        */

    }
    
}
