/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ALNS_Remocoes;

import Principal.Instancia;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */
public class RemocaoMaiorCusto_SemiGulosa extends Remocoes{
    
    public ArrayList<Integer> execute(Solucao sol, Instancia instancia, int tamQ, Random rand){
    
        double alfa = 0.2;
        
        ArrayList<Integer> conjQ = new ArrayList<Integer>();

        //Declarando Listas
        ArrayList<Integer> conjMaquinas = new ArrayList<Integer>(); //Máquina que a tarefa está alocada
        ArrayList<Integer> conjCusto = new ArrayList<Integer>(); //Custo da tarefa
        ArrayList<Integer> conjJobs = new ArrayList<Integer>(); //Conjunto de tarefas
                
        // Pegando o custo de cada tarefa
        for(int k=0; k < instancia.getNumMaqs(); k++){
            for(int auxJ=0; auxJ < sol.getSol().get(k).size(); auxJ++){
        
                int tarefaAnt = 0;
                if(auxJ > 0)
                    tarefaAnt = sol.getSol().get(k).get(auxJ-1);
          
                int tarefa = sol.getSol().get(k).get(auxJ);
                int tempoProc = instancia.getProc()[k][tarefa];
                int tempoPrep = instancia.getPrep()[k][tarefaAnt][tarefa];
                
                //Armazenando os custos
                conjCusto.add(tempoPrep + tempoProc);
                conjJobs.add(tarefa);
                conjMaquinas.add(k);
                        
            }
        }    
        
        //System.out.println(conjCusto);
        //System.out.println(conjJobs);
        //System.out.println(conjMaquinas);
     
        int maiorCusto = Collections.max(conjCusto); //Alocação de maior custo
        int menorCusto = Collections.min(conjCusto); //Alocação de menor custo
        double custoVariacao = (maiorCusto - menorCusto) * alfa; // Variação entre os custos vezes o alfa
        double valorAceitavel = maiorCusto - custoVariacao; //Valor mínimo aceitável para remoção 
        
        //System.out.println("custoVariação: " + custoVariacao + " | valorAceitável: " + valorAceitavel);
        
        //Removendo as q maiores tarefas
        while(tamQ > conjQ.size()){
        
            //Pega um custo aleatório dentre os alfa maiores custos
            int posicao = rand.nextInt(conjCusto.size());
            int valorCusto = conjCusto.get(posicao);
            int contador = 0; //máximo de iterações: o tamanho de conjunto
            while( (valorCusto <= valorAceitavel) && (contador < conjCusto.size() )){
                posicao = rand.nextInt(conjCusto.size());
                valorCusto = conjCusto.get(posicao);
                contador++;
            }
            //Caso não encontre um valor dentro do aceitável, pegue o maior valor
            if(contador >= conjCusto.size()){
                posicao = conjCusto.indexOf(Collections.max(conjCusto));
            }
            
            //Armazenando dados da alocação a ser removida
            int tarefa = conjJobs.get(posicao); //Pega a tarefa correspondente ao custo anterior
            int maquina = conjMaquinas.get(posicao); //Pega a máquina correspondente
            
            //Remove o custo
            conjCusto.remove(posicao); //Remove o custo
            conjJobs.remove(posicao); //Remove a tarefa
            conjMaquinas.remove(posicao); //Remove a máquina
            
            //Atualiza o custo da máquina
            double novoCusto = sol.regraDelta_Retirar2(instancia, maquina, tarefa, sol.getSol().get(maquina).indexOf(tarefa));
            sol.getCustoMaq().set(maquina, (sol.getCustoMaq().get(maquina) + novoCusto));
          
            //Remove a Tarefa
            sol.getSol().get(maquina).remove(sol.getSol().get(maquina).indexOf(tarefa));
            
            //Adicionando tarefa retirada ao conjunto Q
            conjQ.add(tarefa);
            
        }
        
        return conjQ;        
    
    }
    
}
