/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ALNS_Remocoes;

import Principal.Instancia;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */

//Remoção Shaw: seleciona uma tarefa aleatória j' e calcula a diferença R(j',j1) para todas as outras tarefas j1, as tarefas que obterem a menor diferença serão escolhidas.
public class RemocaoShaw extends Remocoes{
    
    public ArrayList<Integer> execute(Solucao sol, Instancia instancia, int tamQ, Random rand){
    
        ArrayList<Integer> conjQ = new ArrayList<Integer>();
        
        //Declarando Listas
        ArrayList<Integer> conjMaquinas = new ArrayList<Integer>(); //Máquina que a tarefa está alocada
        ArrayList<Integer> conjShaw = new ArrayList<Integer>(); //Custo da tarefa
        ArrayList<Integer> conjJobs = new ArrayList<Integer>(); //Conjunto de tarefas
        
        //System.out.println("Passando");
        
        //Pega uma máquina aleatória
        int randMaquina_JLinha = rand.nextInt(instancia.getNumMaqs());
        while(sol.getSol().get(randMaquina_JLinha).size() <= 1){
            randMaquina_JLinha = rand.nextInt(instancia.getNumMaqs());
            //System.out.println("Preso");
        }    

        //Pega uma tarefa aleatória
        int randTarefa_JLinha = rand.nextInt(sol.getSol().get(randMaquina_JLinha).size());
        int tarefa_JLinha = sol.getSol().get(randMaquina_JLinha).get(randTarefa_JLinha);
        
        //System.out.println(tarefa_JLinha);
        
        //Custo Shaw de j'
        int custoShaw_JLinha = instancia.getProc()[randMaquina_JLinha][tarefa_JLinha];
        if(randTarefa_JLinha == 0)
            custoShaw_JLinha += instancia.getPrep()[randMaquina_JLinha][0][tarefa_JLinha];
        else
            custoShaw_JLinha += instancia.getPrep()[randMaquina_JLinha][sol.getSol().get(randMaquina_JLinha).get(randTarefa_JLinha-1)][tarefa_JLinha];
        
        //Armazenando o fator de diferença (Shaw) para todas as outras tarefas
        for(int i=0; i<instancia.getNumMaqs(); i++){
            for(int j=0; j<sol.getSol().get(i).size(); j++){

                //Tarefa j1
                int tarefa_J1 = sol.getSol().get(i).get(j);
                
                //Custo de j1
                int custo_Aux = instancia.getProc()[i][sol.getSol().get(i).get(j)];
                if(j == 0)
                    custo_Aux += instancia.getPrep()[i][0][sol.getSol().get(i).get(j)];
                else
                    custo_Aux += instancia.getPrep()[i][sol.getSol().get(i).get(j-1)][sol.getSol().get(i).get(j)];
                
                //Custo R(j',j1) -> Valor Absoluto!
                int custoShaw_J1 = Math.abs(custoShaw_JLinha - custo_Aux);
                
                //Se a j' for igual a j1, ela recebe um custo infinito
                if(tarefa_J1 == tarefa_JLinha)
                    custoShaw_J1 = Integer.MAX_VALUE;
                
                //Armazenando o custo Shaw de j1 
                conjShaw.add(custoShaw_J1);
                conjJobs.add(tarefa_J1);
                conjMaquinas.add(i);
            }
        }
        
        //System.out.println(conjShaw);
        //System.out.println(conjJobs);
        //System.out.println(conjMaquinas);
        
        //Removendo as q tarefas com menor custo em relação a j'
        while(tamQ > conjQ.size()){
        
            //Pegando o menor custo Shaw
            int posicao = conjShaw.indexOf(Collections.min(conjShaw)); //Pega a posicao de custo menor
            int tarefa = conjJobs.get(posicao); //Pega a tarefa correspondente ao custo anterior
            int maquina = conjMaquinas.get(posicao); //Pega a máquina correspondente
                        
            //Remove o menor custo
            conjShaw.remove(posicao); //Remove o custo
            conjJobs.remove(posicao); //Remove a tarefa
            conjMaquinas.remove(posicao); //Remove a máquina
            
            //Atualiza o custo da máquina
            double novoCusto = sol.regraDelta_Retirar2(instancia, maquina, tarefa, sol.getSol().get(maquina).indexOf(tarefa));
            sol.getCustoMaq().set(maquina, (sol.getCustoMaq().get(maquina) + novoCusto));
          
            //Remove a  Tarefa
            sol.getSol().get(maquina).remove(sol.getSol().get(maquina).indexOf(tarefa));
            
            //Adicionando tarefa retirada ao conjunto Q
            conjQ.add(tarefa);
        }
        
        return conjQ;
    }    
}
