/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Heuristicas;

import Principal.Instancia;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Random;

/**
 *
 * @author DecomLuciano
 */
//Construtivo Parcialmente Guloso Aleatório ASPT(Adaptive Shortest Processing Time)
public class CPG_ASPT {
    
    public static Solucao execute(Instancia instancia, double alfa, Random rand){
        
        //Cria a Solução
        Solucao sol = new Solucao(instancia);
        
        //Mudança (05/10/2017): Inicia todas as tarefas com índice de velocidade aleatório
        for(int j=0;j<instancia.getNumJobs();j++){
            //sol.alterarSpeed(j, rand.nextInt(instancia.getL()));
            sol.alterarSpeed(j, 2);
            //rand.nextInt(instancia.getL()));        
        }
       
        //Conjunto de Tarefas Não Alocada
        ArrayList<Integer> conjTarNaoAloc = new ArrayList<Integer>();
        for(int i=0; i < instancia.getNumJobs(); i++){
            conjTarNaoAloc.add(i);
        }
        
        //Enquanto existirem tarefas não alocadas
        while(conjTarNaoAloc.size() > 0){
            
            //Definindo o Custo Acumulado
            double [][]custoAc = new double[instancia.getNumJobs()+1][instancia.getNumMaqs()+1];
            for(int i=0; i<conjTarNaoAloc.size();i++){
                for(int j=0; j<instancia.getNumMaqs();j++){
                    int job = conjTarNaoAloc.get(i); //Pegando uma Tarefa
                    custoAc[job][j] = CG_ASPT.defineCustoAcu(instancia, job, j, sol); //Quanto menor a pontuação, menor é o tempo acumulado com a inserção da tarefa
                }
            }
            
            //Analisando os Custos
            double maiorValor=0, menorValor=99999999;
            for(int i=0; i<conjTarNaoAloc.size();i++){
                for(int j=0; j<instancia.getNumMaqs();j++){
                   int job = conjTarNaoAloc.get(i); //Pegando uma Tarefa
                   if(custoAc[job][j] > 0){  //Desprezar o custo 0, pois são as tarefas já alocadas                   
                      if(custoAc[job][j] > maiorValor)
                         maiorValor = custoAc[job][j];
                      if(custoAc[job][j] < menorValor)
                         menorValor = custoAc[job][j];
                   }     
               }     
            }
            
            //System.out.println("gmin:" + menorValor + " gmax:" + maiorValor);
            
            //Calculando a Variacao
            double variacaoInt = maiorValor - menorValor;
            if(variacaoInt == 0) //Se a varicao for 0 - Caso onde não há diferença de tempo
               variacaoInt = 1;
            double variacaoDoub = variacaoInt * alfa;
            
            //Escolhendo de Forma Randomica a Alocacao que obedece a Variação
            int randomicoMaquina, randomicoTarefa; int maquinaEscolhida = -1; int tarefaEscolhida = -1;
            //Random rand = new Random();
            while(maquinaEscolhida == -1){

               randomicoMaquina = rand.nextInt(instancia.getNumMaqs()); //Pega uma máquina randomicamente
               int i = rand.nextInt(conjTarNaoAloc.size()); //Pega uma tarefa randomicamente
               randomicoTarefa = conjTarNaoAloc.get(i);
               
               //Avalia se esta maquina obedece a variação
               if( (custoAc[randomicoTarefa][randomicoMaquina] != 0) && (custoAc[randomicoTarefa][randomicoMaquina] < (menorValor + variacaoDoub)) ){
                  maquinaEscolhida = randomicoMaquina;
                  tarefaEscolhida = randomicoTarefa;
               }
            }
            
            //double aux = custoAc[tarefaEscolhida][maquinaEscolhida];
            //System.out.println("g: " + aux);
            
            //Adicionar Tarefa a Solução
            sol.getSol().get(maquinaEscolhida).add(tarefaEscolhida);
            
            //Retirar Tarefa do conjunto de tarefas não alocadas
            for(int i=0; i<conjTarNaoAloc.size();i++){
                int job = conjTarNaoAloc.get(i); //Pegando uma Tarefa
                if(job == tarefaEscolhida){
                    conjTarNaoAloc.remove(i);
                }
            }
            
        }
        
        //Define o custo para as Máquinas
        sol.definirCustoMaqs();
        
        return sol;
    }
    
}
