/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Heuristicas;

import Principal.Dominancia;
import Principal.Instancia;
import Principal.Maquinas;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;

/**
 *
 * @author DecomLuciano
 */
//Busca Local: Estartégia First Improvement e Vizinhança TMD(Troca em Máquinas Diferentes) ou SMD(Swap Between Different Machines)
public class FI_TMD {
    
    public static Solucao execute(Instancia instancia, Solucao s){
        
        //Mudança (04/10/2017): Não irá modificar a solução s (original)
        Solucao sol2 = new Solucao(instancia);
        sol2.clonarSolucoes(s);
        
        //Armazena as máquinas da Solução por ordem decrescente
        ArrayList<Maquinas> make = new ArrayList<Maquinas>();
        for(int i=0; i < instancia.getNumMaqs(); i++){
            make.add(new Maquinas(i, sol2.getCustoMaq().get(i)));
        }
        Collections.sort(make);
        
        //
        //ArrayList<Integer> vectorL1 = new ArrayList<Integer>();
        //ArrayList<Integer> vectorL2 = new ArrayList<Integer>();
        //for(int l=0;l<instancia.getL();l++){
        //    vectorL1.add(l);
        //    vectorL2.add(l);
        //}    
        //Collections.shuffle(vectorL1);
        //Collections.shuffle(vectorL2);
        
        
        //Percorrendo as tarefas da máquina K
        for(int k=0; k < instancia.getNumMaqs(); k++){
            for(int auxJ=0; auxJ < sol2.getSol().get(make.get(k).getIndice()).size(); auxJ++){
                
                //NOVO: Percorrendo índice de velocidades para para todas as tarefas da máquina K
                //for(int indL1=0; indL1 < instancia.getL() ; indL1++){
                
                    //
                    //int l1 = vectorL1.get(indL1); 
                    
                    //Percorrendo as tarefas da máquina i
                    for(int i=instancia.getNumMaqs()-1; i >= 0; i--){
                        for(int auxJLin=0; auxJLin < sol2.getSol().get(make.get(i).getIndice()).size(); auxJLin++){

                            //NOVO: Percorrendo índice de velocidades para para todas as tarefas da máquina i
                            //for(int indL2=0; indL2 < instancia.getL() ; indL2++){

                                //
                                //int l2 = vectorL2.get(indL2);
                                                                
                                //Indices das máquinas
                                int indiceK = make.get(k).getIndice();
                                int indiceI = make.get(i).getIndice();
                                
                                //Somente para máquinas diferentes
                                if(indiceI != indiceK){
                                    
                                    //Custo Antigo
                                    double custoAntigoK = sol2.getCustoMaq().get(indiceK);
                                    double custoAntigoI = sol2.getCustoMaq().get(indiceI);

                                    /*
                                    //NOVO: Alterando as velocidades das tarefas e armazenando os custos antigos
                                    //O custo é atualizado porque a tarefa deve ser removida já com o custo da nova VELOCIDADE
                                    int j_antiga = sol2.getSol().get(indiceK).get(auxJ);
                                    int jLin_antiga = sol2.getSol().get(indiceI).get(auxJLin);
                                    //Atualizando custos
                                    double custoTrocarVel_j = sol2.regraDelta_Velocidade(instancia, indiceK, j_antiga, l1);
                                    sol2.getCustoMaq().set(indiceK, (sol2.getCustoMaq().get(indiceK) + custoTrocarVel_j));
                                    double custoTrocarVel_jLin = sol2.regraDelta_Velocidade(instancia, indiceI, jLin_antiga, l2);
                                    sol2.getCustoMaq().set(indiceI, (sol2.getCustoMaq().get(indiceI) + custoTrocarVel_jLin));
                                    //Trocando velocidades
                                    int antigaSpeed_j = sol2.getSpeed()[j_antiga];
                                    sol2.alterarSpeed(j_antiga, l1);
                                    int antigaSpeed_jLin = sol2.getSpeed()[jLin_antiga];
                                    sol2.alterarSpeed(jLin_antiga, l2);
                                    */
                                    
                                    //Tarefa J
                                    int j = sol2.getSol().get(indiceK).remove(auxJ);
                                    int auxJob = j;

                                    //Tarefa JLinha
                                    int jLin = sol2.getSol().get(indiceI).remove(auxJLin);

                                    //Adicionando
                                    sol2.getSol().get(indiceK).add(auxJ, jLin);
                                    sol2.getSol().get(indiceI).add(auxJLin, auxJob);

                                    //Atualizando Custos
                                    double custoRetirarJ = sol2.regraDelta_Retirar2(instancia, indiceK, j, auxJ);
                                    sol2.getCustoMaq().set(indiceK, (sol2.getCustoMaq().get(indiceK) + custoRetirarJ));
                                    double custoRetirarJLin = sol2.regraDelta_Retirar2(instancia, indiceI, jLin, auxJLin);
                                    sol2.getCustoMaq().set(indiceI, (sol2.getCustoMaq().get(indiceI) + custoRetirarJLin));
                                    double custoInserirJ = sol2.regraDelta_Inserir2(instancia, indiceI, j, auxJLin);
                                    sol2.getCustoMaq().set(indiceI, (sol2.getCustoMaq().get(indiceI) + custoInserirJ));
                                    double custoInserirJLin = sol2.regraDelta_Inserir2(instancia, indiceK, jLin, auxJ);
                                    sol2.getCustoMaq().set(indiceK, (sol2.getCustoMaq().get(indiceK) + custoInserirJLin));

                                    //NOVO: sol2 domina s ?
                                    if(Dominancia.definirDominancia(sol2, s) == 1 || Dominancia.definirDominancia(sol2, s) == 2 || Dominancia.definirDominancia(sol2, s) == 5){
                                        //Fim da busca!
                                        return sol2;
                                    }
                                    //Desfazendo o movimento de troca
                                    else{

                                        //Máquina K: Reinserindo a tarefa j na posição auxJ 
                                        sol2.getSol().get(indiceK).remove(auxJ);
                                        sol2.getSol().get(indiceK).add(auxJ, j);
                                        sol2.getCustoMaq().set(indiceK, custoAntigoK);

                                        //Máquina I: Reinserindo a tarefa jLin na posição auxJLin
                                        sol2.getSol().get(indiceI).remove(auxJLin);
                                        sol2.getSol().get(indiceI).add(auxJLin, jLin);
                                        sol2.getCustoMaq().set(indiceI, custoAntigoI);
                                        
                                        //NOVO: Atualiza as tarefas com as velocidades antigas
                                        //sol2.alterarSpeed(j_antiga, antigaSpeed_j);
                                        //sol2.alterarSpeed(jLin_antiga, antigaSpeed_jLin);
                                        
                                    }
                                }
                            //}    
                        }
                    }    
               // }
            }
         }
                
        //Fim da busca! Não encontrou uma solução melhor nesta vizinhança
        return sol2;
    }
   
    
}
