/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Heuristicas;

/**
 *
 * @author UFOPLuciano
 */

//Implementação do Alexandre
public class MetodoHungaro {
    
    public int[] hungarian(int n, double cost[][], int xy[]){
        
        //Multiplicando por -1
        for(int i=0; i<n; i++){
            for(int j=0; j<n; j++){
                cost[i][j] = (cost[i][j] * -1) ;
                //System.out.println(cost[i][j])
            }    
        }
        
        
        int ret = 0;                      //weight of the optimal matching
        int max_match = 0;                //number of vertices in current matching
        int yx[] = new int[n];

        boolean S[] = new boolean[n];
        boolean T[] = new boolean[n];           //sets S and T in algorithm
        double slack[] = new double[n];         //as in the algorithm description
        double slackx[] = new double[n];       //slackx[y] such a vertex, that
                                     // l(slackx[y]) + l(y) - w(slackx[y],y) = slack[y]
    
        int prev[] = new int[n];          //array for memorizing alternating paths

        double lx[] = new double[n];
        double ly[] = new double[n];

        //Step 0: init_labels
        this.init_labels(n, xy, yx, lx, ly, cost);
        
        //Algoritmo Principal
        this.augment(n, max_match, S, T, prev, xy, yx, lx, ly, cost, slack, slackx);
       
        return xy;
    }
    
    public void augment(int n, int max_match, boolean S[], boolean T[], int prev[], int xy[], int yx[], 
                        double lx[], double ly[], double cost[][], double slack[], double slackx[]){
    
        if (max_match == n){
            
            //for(int i = 0; i < n; i++){
            //    System.out.print(slackx[i] + "  ");
            //}
            //System.out.println();
            
            return;
        }
        
        //Step 1
        int []q = new int [n];

        int x, y, root = 0;           //just counters and root vertex
        int wr = 0, rd = 0;

        for(int i = 0; i < n; i++){
           S[i] = T[i] = false;
           prev[i] = -1;
        }

        for (x = 0; x < n; x++){            //finding root of the tree
            if (xy[x] == -1){
                q[wr++] = root = x;
                prev[x] = -2;
                S[x] = true;
                break;
            }
        }    
        
        for (y = 0; y < n; y++){            //initializing slack array
            
            slack[y] = lx[root] + ly[y] - cost[root][y];
            slackx[y] = root;
            
            //System.out.println("y=" + y + " -> " + lx[root] + " + " + ly[y] + " - " + cost[root][y] + " = " + slack[y]);
        }
        //System.out.println();
        
        //Step 2
        
        //second part of augment() function
        while (true){
            
            while (rd < wr){
                
                x = q[rd++];                                                //current vertex from X part
                for (y = 0; y < n; y++)                                     //iterate through all edges in equality graph
                    if (cost[x][y] == lx[x] + ly[y] &&  !T[y]){
                        
                        if (yx[y] == -1) break;                             //an exposed vertex in Y found, so
                                                                            //augmenting path exists!
                        T[y] = true;                                        //else just add y to T,
                        q[wr++] = yx[y];                                    //add vertex yx[y], which is matched
                                                                            //with y, to the queue
                        //add_to_tree(yx[y], x);                            //add edges (x,y) and (y,yx[y]) to the tree
                        this.add_to_tree(yx[y], x, S, prev, lx, ly, cost, slack, slackx, n);
                    }
                if (y < n) break;                                           //augmenting path found!
            }
            if (y < n) break;                                               //augmenting path found!

            //update_labels();                                                //augmenting path not found, so improve labeling
            this.update_labels(n, T, slack, S, lx, ly);
            wr = rd = 0;
            
            for (y = 0; y < n; y++){
            //in this cycle we add edges that were added to the equality graph as a
            //result of improving the labeling, we add edge (slackx[y], y) to the tree if
            //and only if !T[y] &&  slack[y] == 0, also with this edge we add another one
            //(y, yx[y]) or augment the matching, if y was exposed
                if (!T[y] &&  slack[y] == 0){
                
                    if (yx[y] == -1){                                        //exposed vertex in Y found - augmenting path exists!
                    
                        x = (int) slackx[y];
                        break;
                    }
                    else{
                    
                        T[y] = true;                                        //else just add y to T,
                        if (!S[yx[y]]){
                        
                            q[wr++] = yx[y];                                //add vertex yx[y], which is matched with
                                                                            //y, to the queue
                           // add_to_tree(yx[y], slackx[y]);                  //and add edges (x,y) and (y,
                                                                            //yx[y]) to the tree
                           this.add_to_tree(yx[y], (int) slackx[y], S, prev, lx, ly, cost, slack, slackx, n);
                        }
                    }
                }
            }
            if (y < n) break;                                               //augmenting path found!
        }
        
        if (y < n){
            
            max_match++; //increment matching
            
            //in this cycle we inverse edges along augmenting path
            for (int cx = x, cy = y, ty; cx != -2; cx = prev[cx], cy = ty){
                
                ty = xy[cx];
                yx[cy] = cx;
                xy[cx] = cy;
            }
            
            //System.out.println("Prévia");
            //for(int i = 0; i < n; i++){
            //    System.out.print(xy[i] + "  ");
            //}
            //System.out.println();
            
            //augment();     //recall function, go to step 1 of the algorithm
            this.augment(n, max_match, S, T, prev, xy, yx, lx, ly, cost, slack, slackx);
        }

    }
    
    public void init_labels(int n, int xy[], int yx[], double lx[], double ly[], double cost[][]){
        for(int i = 0; i < n; i++){
            xy[i] = yx[i] = -1;
            lx[i] = ly[i] = 0.0;//(double)(-INT_MAX);
        }
        for (int x = 0; x < n; x++)
            for (int y = 0; y < n; y++)
                lx[x] = Math.max(lx[x], cost[x][y]);
    }
    
    public void add_to_tree(int x, int prevx, boolean S[], int prev[], double lx[], double ly[], 
                            double cost[][], double slack[], double slackx[], int n){
            
    //x - current vertex,prevx - vertex from X before x in the alternating path,
    //so we add edges (prevx, xy[x]), (xy[x], x)
    
        S[x] = true;                    //add x to S
        prev[x] = prevx;                //we need this when augmenting
        for (int y = 0; y < n; y++){    //update slacks, because we add new vertex to S
            if (lx[x] + ly[y] - cost[x][y] < slack[y]){
                slack[y] = lx[x] + ly[y] - cost[x][y];
                slackx[y] = x;
            }
        }
    }
    
    public void update_labels(int n, boolean T[], double slack[], boolean S[], double lx[], double ly[]){
    
        int x, y, delta = Integer.MAX_VALUE;         //init delta as infinity
        
        for (y = 0; y < n; y++)            //calculate delta using slack
            if (!T[y])
                delta = (int) Math.min(delta, slack[y]);
        
        for (x = 0; x < n; x++)            //update X labels
            if (S[x]) lx[x] -= delta;
        
        for (y = 0; y < n; y++)            //update Y labels
            if (T[y]) ly[y] += delta;
        
        for (y = 0; y < n; y++)            //update slack array
            if (!T[y])
                slack[y] -= delta;
    }
    
}
