/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package Partes_MOALNSD;

import ALNS_Insercoes.*;
import ALNS_Remocoes.*;
import Principal.Instancia;
import Principal.Solucao;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */

//Usado no PALNS_D
public class ALNS_MULT{
    
    //
    private double t; //Tempo para execução
    private Instancia instancia; //Objeto contento os dados da instância do problema
    private Random rand;
    private int tamQ;
    
    //Métodos de inserção e remoção
    private ArrayList<Insercoes> insercoes;
    private ArrayList<Remocoes> remocoes;
    private static final double Q=0.05;
    //private static final double Q=0.20;
  
    //Atributor usados na aceitação do ALNS
    private double T; //temperatura
    private static final double alfa = 0.99; //fator para atualizar a temperatura
    
    ///Manipula as probabilidades de seleção
    private ArrayList<Double> Prob_insercoes;
    private ArrayList<Double> Prob_remocoes;
    private ArrayList<Double> Rho_insercoes;
    private ArrayList<Double> Rho_remocoes;
        
    //Prêmios inspirando no LA-ALNS
    private static final double premio_Best     = 40; 
    private static final double premio_Current  = 10;  //Teste 2: 10
    private static final double premio_Accepted = 5;   //Teste 2: 5
    private static final double penalidade      = 0.5; //Teste 2: 0.5 
    private char estado; // B=best, C=current, A=accepted e P=not accepted
            
    public ALNS_MULT (double tempoExec, Instancia instancia, Random rand){
        
        this.t = tempoExec;
        this.instancia = instancia;
        this.rand = rand;
//        elite = new Elite(instancia, new Solucao(instancia), new ArrayList<Solucao>());
        
        //Q***********************
        //this.tamQ = (int) ((int) instancia.getNumJobs() * this.Q);
        this.tamQ = Integer.max(4, (int) ((int) instancia.getNumJobs() * this.Q));
        //System.out.println(this.tamQ);
        
        //this.tamQ = 6;
        
        //Iniciando métodos de remoção
        this.remocoes = new ArrayList<Remocoes>();
        remocoes.add(new RemocaoAleatoria());
        remocoes.add(new RemocaoMaiorCusto_Gulosa());
        remocoes.add(new RemocaoMaiorCusto_SemiGulosa());
        remocoes.add(new RemocaoMaqMaior());
        remocoes.add(new RemocaoMaqAleatoria()); 
        remocoes.add(new RemocaoShaw());
        
        //Iniciando métodos de inserção
        this.insercoes = new ArrayList<Insercoes>();
        //insercoes.add(new InsercaoLambda());
        //insercoes.add(new InsercaoGuloso());
        //insercoes.add(new InsercaoSemiGuloso());
        //insercoes.add(new InsercaoHungaro());
        insercoes.add(new Insercao_ILS());
        //insercoes.add(new InsercaoArrependimento()); 
                
        //Iniciando Probabilidades
        Rho_remocoes = new ArrayList<Double>();
        Prob_remocoes = new ArrayList<Double>();
        for(int i=0; i<remocoes.size(); i++){
            Rho_remocoes.add(1.0);
            Prob_remocoes.add(100.0/remocoes.size());
        }    
        Rho_insercoes = new ArrayList<Double>();    
        Prob_insercoes = new ArrayList<Double>();
        for(int i=0; i<insercoes.size(); i++){
            Rho_insercoes.add(1.0);
            Prob_insercoes.add(100.00/insercoes.size());
        }   
        
    }   

    public ArrayList<Double> getRho_insercoes() {
        return Rho_insercoes;
    }

    public void setRho_insercoes(ArrayList<Double> Rho_insercoes) {
        this.Rho_insercoes = Rho_insercoes;
    }

    public ArrayList<Double> getRho_remocoes() {
        return Rho_remocoes;
    }

    public void setRho_remocoes(ArrayList<Double> Rho_remocoes) {
        this.Rho_remocoes = Rho_remocoes;
    }
    
    
    public ArrayList<Double> getProb_insercoes() {
        return Prob_insercoes;
    }

    public void setProb_insercoes(ArrayList<Double> Prob_insercoes) {
        this.Prob_insercoes = Prob_insercoes;
    }

    public ArrayList<Double> getProb_remocoes() {
        return Prob_remocoes;
    }

    public void setProb_remocoes(ArrayList<Double> Prob_remocoes) {
        this.Prob_remocoes = Prob_remocoes;
    }

        
    public Solucao execute(Solucao sol) throws IOException{
        
        //FO2 é a função de avaliação: Tchebycheff Approach (TCH)
        
        //Iniciando contagem de tempo
        long tempoIni = System.currentTimeMillis(); // Iniciando Contagem do Tempo
        
        //Tempo limite: é a própria variável t, aqui o tempo de execução é uma fração do tempo do MOEA/D
        double tempoLimite = this.t;
        
        //Criando a solução que vai armazenar o melhor resultado
        Solucao solBest = new Solucao(this.instancia);
        
        //Solução não é construída, porque elas são construídas no MOEA/D usando o CPG! 
        //sol é recebida como parâmetro já com os pesos adequados para a busca com o ALNS!
        solBest.clonarSolucoes(sol);
                
        //Temperatura inicial: uma solução 10% pior que a solução inicial tem 50% de chance de ser escolhida
//        this.T = (0.1 * sol.calcularFO())/Math.log(2);
          this.T = (0.1 * sol.calcularFO2())/Math.log(2);
        
        //Enquanto houver tempo de execução
        long subTempo = 0; //Receberá o tempo gasto até o momento
        
        while(subTempo < (tempoLimite * 0.99) ){
            
            //Solução Corrente
            Solucao sol2 = new Solucao(this.instancia);
            sol2.clonarSolucoes(sol);
            
            //Método de Remoção
            int metodoRemocao = roleta(this.Prob_remocoes);
            ArrayList<Integer> conjQ = this.remocoes.get(metodoRemocao).execute(sol2, instancia, this.tamQ, rand);
            
            //Método de Inserção
            int metodoInsercao = roleta(this.Prob_insercoes);
            sol2 = this.insercoes.get(metodoInsercao).execute(sol2, instancia, conjQ, rand);
            
            //Busca Local
            sol2 = RVND_MULT.execute(this.instancia, sol2, rand);
        
            //double delta = sol2.calcularFO() - sol.calcularFO();
            double delta = sol2.calcularFO2() - sol.calcularFO2();
            double x = rand.nextDouble();
            
            //
            this.estado = 'P';
            
            //É melhor que a solução corrente
            if (delta < 0){
                sol.clonarSolucoes(sol2);
                this.estado = 'C';
            }
            //Passa pelo critério de aceitação, também atualiza a solução corrente
            else if(x < Math.exp(-delta/T)){
                sol.clonarSolucoes(sol2);
                this.estado = 'A';
            }
           
            //Atualiza a melhor solução
            if(sol2.calcularFO2() < solBest.calcularFO2()){
                this.estado = 'B';
                solBest.clonarSolucoes(sol2);
            }
            
            //Atualiza a temperatura
            this.T = this.alfa * this.T;
            
            //Solicita o prêmio
            double premio = this.aplicaPremio(this.estado);
            
            //Atualizar Probabilidades segundo Ropke e Psinger
            this.atualizaProb_Ropke(metodoRemocao, metodoInsercao, premio);
            
            //Calcula o tempo gasto!
            long tempoFin = System.currentTimeMillis();
            subTempo = tempoFin - tempoIni;
        
        }
        
        return solBest;
        
    }
    
    
    //Atualiza as probabilidades 
    public void atualizaProb_Ropke(int metodoRemocao, int metodoInsercao, double premio){
    
        //Qual usar?
        double lambda = 0.6; //Teste 2: 0.9
        
        //Aplica o prêmio
        //System.out.println(metodoRemocao);
        double rho_remocao = lambda * this.Rho_remocoes.get(metodoRemocao) + ((1 - lambda) * premio);
        this.Rho_remocoes.set(metodoRemocao, rho_remocao);
        
        double rho_insercao = lambda * this.Rho_insercoes.get(metodoInsercao) + ((1 - lambda) * premio);
        this.Rho_insercoes.set(metodoInsercao, rho_insercao);
        
    }
    
    //Retorna o prêmio
    public double aplicaPremio(char estado){
        
        //Prêmio
        double premio = 0;
        switch (estado) {
            case 'B':
                premio = this.premio_Best;
                break;
            case 'C':
                premio = this.premio_Current;
                break;
            case 'A':
                premio = this.premio_Accepted;
                break;
            case 'P':
                premio = this.penalidade;
                break;    
            default:
                break;
        }
        
        return premio;
    }
    
    public int roleta(ArrayList<Double> conj_Prob){
        
        //Roda a roleta!
        double randRoleta = 100 * (this.rand.nextDouble());
        
        //System.out.println("RandRemoção: " + randRoleta);
        double acumulado = 0;
        int metodoEscolhido = 0;
        for(int i=0; i<conj_Prob.size(); i++){
            acumulado += conj_Prob.get(i);
            if(acumulado > randRoleta){
                metodoEscolhido = i;
                break;
            }    
        }
        
        return metodoEscolhido;
    }
    
}
