/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package Partes_MOALNSD;

import ALNS_Insercoes.*;
import ALNS_Remocoes.*;
import Heuristicas.Perturb;
import Principal.Instancia;
import Principal.Solucao;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */

//Usado no PILS/D
public class ILS_MULT{
    
    //
    private double t; //Tempo para execução
    private Instancia instancia; //Objeto contento os dados da instância do problema
    private Random rand;
    
    public ILS_MULT (double tempoExec, Instancia instancia, Random rand){
        
        this.t = tempoExec;
        this.instancia = instancia;
        this.rand = rand;
    }   
        
    public Solucao execute(Solucao sol) throws IOException{
        
        //FO2 é a função de avaliação: Tchebycheff Approach (TCH)
        
        //Iniciando contagem de tempo
        long tempoIni = System.currentTimeMillis(); // Iniciando Contagem do Tempo
        
        //Tempo limite: é a própria variável t, aqui o tempo de execução é uma fração do tempo do MOEA/D
        double tempoLimite = this.t;
        
        //Criando a solução que vai armazenar o melhor resultado
        Solucao solBest = new Solucao(this.instancia);
        
        //Solução não é construída, porque elas são construídas no MOEA/D usando o CPG! 
        //sol é recebida como parâmetro já com os pesos adequados para a busca com o ALNS!
        solBest.clonarSolucoes(sol);
        
        int nivel = 1;
        
        //Enquanto houver tempo de execução
        long subTempo = 0; //Receberá o tempo gasto até o momento
        
        while(subTempo < (tempoLimite * 0.99) ){
            
            //Solução Corrente
            Solucao sol2 = new Solucao(this.instancia);
            sol2.clonarSolucoes(sol);
            
            //Enquanto houver vezes nível
            int vezes = 0; //iniciando o vezes nível
            while(vezes < 5){
                
                int perturbmax = nivel + 1;
                int perturb = 0;
                     
                //Enquanto houver pertubações
                while(perturb < perturbmax){
                    perturb++;
                    //Perturbação
                    sol2 = Perturb.execute(sol2, instancia);
                }    
            
                //Busca Local
                sol2 = RVND_MULT.execute(this.instancia, sol2, rand);

                //double delta = sol2.calcularFO() - sol.calcularFO();
                double delta = sol2.calcularFO2() - sol.calcularFO2();

                //É melhor que a solução corrente
                if (delta < 0){
                    sol.clonarSolucoes(sol2);
                    vezes = 0;
                }
                vezes++;
                
            }
            
            nivel++;
            if(nivel > 3){
                nivel = 1;
            }
            
            //Calcula o tempo gasto!
            long tempoFin = System.currentTimeMillis();
            subTempo = tempoFin - tempoIni;
        
        }
        
        return solBest;
    }
    
}
