/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package Partes_MOALNSD;

import ALNS_Insercoes.*;
import ALNS_Remocoes.*;
import Principal.Instancia;
import Principal.Solucao;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */

/*Algoritmo da Tese usando no MOEA/D + LA-ALNS --  Não modificado deste então*/
public class LA_ALNS_MULT{
    
    //
    private double t; //Tempo para execução
    private Instancia instancia; //Objeto contento os dados da instância do problema
    private Random rand;
    private int tamQ;
    
    //Métodos de inserção e remoção
    private ArrayList<Insercoes> insercoes;
    private ArrayList<Remocoes> remocoes;
    private static final double Q=0.05;
    //private static final double Q=0.20;
  
    //Atributor usados na aceitação do ALNS
    private double T; //temperatura
    private static final double alfa = 0.99; //fator para atualizar a temperatura
    
    //Learning Automata
    private ArrayList<Double> LA_insercoes;
    private ArrayList<Double> LA_remocoes;
    private ArrayList<Double> Prob_insercoes;
    private ArrayList<Double> Prob_remocoes;
    private static final double premio_Best = 0.2;
    private static final double premio_Current = 0.1;
    private static final double premio_Accepted = 0.05;
    private static final double penalidade = 0.02; 
    private int intervaloK;  
    private char estado; // B=best, C=current, A=accepted e P=not accepted 
            
    public LA_ALNS_MULT (double tempoExec, Instancia instancia, Random rand){
        
        this.t = tempoExec;
        this.instancia = instancia;
        this.rand = rand;
//        elite = new Elite(instancia, new Solucao(instancia), new ArrayList<Solucao>());
        
        //Q***********************
        //this.tamQ = (int) ((int) instancia.getNumJobs() * this.Q);
        this.tamQ = Integer.max(4, (int) ((int) instancia.getNumJobs() * this.Q));
        //System.out.println(this.tamQ);
        
        //this.tamQ = 6;
        
        //Iniciando métodos de remoção
        this.remocoes = new ArrayList<Remocoes>();
        remocoes.add(new RemocaoAleatoria());
        remocoes.add(new RemocaoMaiorCusto_Gulosa());
        remocoes.add(new RemocaoMaiorCusto_SemiGulosa());
        remocoes.add(new RemocaoMaqMaior());
        remocoes.add(new RemocaoMaqAleatoria()); 
        remocoes.add(new RemocaoShaw());
        
        //Iniciando métodos de inserção
        this.insercoes = new ArrayList<Insercoes>();
        insercoes.add(new InsercaoLambda());
        insercoes.add(new InsercaoGuloso());
        insercoes.add(new InsercaoSemiGuloso());
        insercoes.add(new InsercaoHungaro());
        insercoes.add(new Insercao_ILS());
        insercoes.add(new InsercaoArrependimento()); 
                
        //Iniciando as Learning Automata
        LA_remocoes = new ArrayList<Double>();
        Prob_remocoes = new ArrayList<Double>();
        for(int i=0; i<remocoes.size(); i++){
            LA_remocoes.add(1.0);
            Prob_remocoes.add(100.0/remocoes.size());
        }    
        LA_insercoes = new ArrayList<Double>();
        Prob_insercoes = new ArrayList<Double>();
        for(int i=0; i<insercoes.size(); i++){
            LA_insercoes.add(1.0);
            Prob_insercoes.add(100.00/insercoes.size());
        }   
        
        //Intervalo K: número de heurísticas vezes 6
        this.intervaloK = Integer.max(remocoes.size(), insercoes.size()) * 6;
        
    }    

    public ArrayList<Double> getLA_insercoes() {
        return LA_insercoes;
    }

    public void setLA_insercoes(ArrayList<Double> LA_insercoes) {
        this.LA_insercoes = LA_insercoes;
    }

    public ArrayList<Double> getLA_remocoes() {
        return LA_remocoes;
    }

    public void setLA_remocoes(ArrayList<Double> LA_remocoes) {
        this.LA_remocoes = LA_remocoes;
    }
    
    public ArrayList<Double> getProb_insercoes() {
        return Prob_insercoes;
    }

    public void setProb_insercoes(ArrayList<Double> Prob_insercoes) {
        this.Prob_insercoes = Prob_insercoes;
    }

    public ArrayList<Double> getProb_remocoes() {
        return Prob_remocoes;
    }

    public void setProb_remocoes(ArrayList<Double> Prob_remocoes) {
        this.Prob_remocoes = Prob_remocoes;
    }

        
    public Solucao execute(Solucao sol) throws IOException{
        
        //Iniciando contagem de tempo
        long tempoIni = System.currentTimeMillis(); // Iniciando Contagem do Tempo
        
        //Tempo limite: é a própria variável t, aqui o tempo de execução é uma fração do tempo do MOEA/D
        double tempoLimite = this.t;
        //System.out.println("Tempo Limite: " + tempoLimite/1000 + " segundos");
        
        //Criando a solução que vai armazenar o melhor resultado
        Solucao solBest = new Solucao(this.instancia);
        
        //Solução não é construída, porque elas são construídas no MOEA/D usando o CPG! 
        //sol é recebida como parâmetro já com os pesos adequados para a busca com o LA-ALNS!
        solBest.clonarSolucoes(sol);
                
        //Temperatura inicial: uma solução 10% pior que a solução inicial tem 50% de chance de ser escolhida
//        this.T = (0.1 * sol.calcularFO())/Math.log(2);
          this.T = (0.1 * sol.calcularFO2())/Math.log(2);
        
        
        //Enquanto houver tempo de execução
        long subTempo = 0; //Receberá o tempo gasto até o momento
        int k = 0; //controla a atualização da Learning Automata
        
        int cont = 0;
               
        while(subTempo < (tempoLimite * 0.95) ){
            
            //System.out.println("Passei!");
            
            cont++;
            
            //Solução Corrente
            Solucao sol2 = new Solucao(this.instancia);
            sol2.clonarSolucoes(sol);
            
            //System.out.println("\t \t Ponto 1");
            
            //Método de Remoção
            int metodoRemocao = roleta(this.Prob_remocoes);
            ArrayList<Integer> conjQ = this.remocoes.get(metodoRemocao).execute(sol2, instancia, this.tamQ, rand);
            
            //Método de Inserção
            int metodoInsercao = roleta(this.Prob_insercoes);
            sol2 = this.insercoes.get(metodoInsercao).execute(sol2, instancia, conjQ, rand);
            //sol2.calcularMakespan();
            
            //System.out.println("\t \t Ponto 2");
            
            //Busca Local
            //long tempoIni2 = System.currentTimeMillis(); //     
            sol2 = RVND_MULT.execute(this.instancia, sol2, rand);
            //long tempoFin2 = System.currentTimeMillis();
            //long subTempo2 = tempoFin2 - tempoIni2;
            //System.out.println(subTempo2);
            
            //System.out.println("Pós");
                
            //System.out.println("\t \t Ponto 3");
            //
            //double delta = sol2.calcularFO() - sol.calcularFO();
            double delta = sol2.calcularFO2() - sol.calcularFO2();
            double x = rand.nextDouble();
            
            //
            this.estado = 'P';
            
            //É melhor que a solução corrente
            if (delta < 0){
                sol.clonarSolucoes(sol2);
                this.estado = 'C';
            }
            //Passa pelo critério de aceitação, também atualiza a solução corrente
            else if(x < Math.exp(-delta/T)){
                sol.clonarSolucoes(sol2);
                this.estado = 'A';
            }
           
            //Atualiza a melhor solução
            //if(sol2.calcularFO() < solBest.calcularFO()){
            if(sol2.calcularFO2() < solBest.calcularFO2()){
                this.estado = 'B';
                solBest.clonarSolucoes(sol2);
                //this.elite.atualizaBest(sol2);
            }
            //Atualiza a temperatura
            this.T = this.alfa * this.T;
            //System.out.println(this.T);
            
            //Learning Automata
            atualizaLA(metodoRemocao, metodoInsercao);
            if(k == this.intervaloK){
                //Atualiza probabilidades
                atualizaProb();
                k = 0;
            }
            k++;    
            
            //System.out.println("\t \t Ponto 4");
            
            //Calcula o tempo gasto!
            long tempoFin = System.currentTimeMillis();
            subTempo = tempoFin - tempoIni;
          //System.out.println("Passei");  
        }
        //System.out.println("TempoFim: \t" + subTempo/1000);
        //System.out.println("Iterações LA-ALNS: \t " + cont);

        return solBest;
        
    }
    
    public void atualizaProb(){
        
        //Remoções
        double sum_Remocoes = 0;
        for(int i=0; i<LA_remocoes.size(); i++)
            sum_Remocoes += LA_remocoes.get(i);
        for(int i=0; i<Prob_remocoes.size(); i++)
            Prob_remocoes.set(i, (LA_remocoes.get(i) / sum_Remocoes) * 100);
        
        //Inserções
        double sum_Inserções = 0;
        for(int i=0; i<LA_insercoes.size(); i++)
            sum_Inserções += LA_insercoes.get(i);
        for(int i=0; i<Prob_insercoes.size(); i++)
            Prob_insercoes.set(i, (LA_insercoes.get(i) / sum_Inserções) * 100);
    }
    
    public void atualizaLA(int metodoRemocao, int metodoInsercao){
        
        if(this.estado == 'P')
            this.aplicarPenalidade(metodoRemocao, metodoInsercao);
        else
            this.aplicarPremio(metodoRemocao, metodoInsercao);
    }
    
    public void aplicarPremio(int metodoRemocao, int metodoInsercao){
    
        //Prêmio
        double premio = 0;
        if(estado == 'B')
            premio = this.premio_Best;
        else if(estado == 'C')
            premio = this.premio_Current;
        else if(estado == 'A')
            premio = this.premio_Accepted;
        
        //Learning Automata - Remoções
        for(int i=0; i<LA_remocoes.size(); i++){
            if(metodoRemocao == i){
                double auxValue = LA_remocoes.get(i) + premio * (1 - LA_remocoes.get(i));
                LA_remocoes.set(i, auxValue);
            }
            else{
                double auxValue = (1 - premio) * LA_remocoes.get(i);
                LA_remocoes.set(i, auxValue);
            }
        }
        
        //Learning Automata - Inserções
        for(int i=0; i<LA_insercoes.size(); i++){
            if(metodoInsercao == i){
                double auxValue = LA_insercoes.get(i) + premio * (1 - LA_insercoes.get(i));
                LA_insercoes.set(i, auxValue);
            }
            else{
                double auxValue = (1 - premio) * LA_insercoes.get(i);
                LA_insercoes.set(i, auxValue);
            }
        }
    }
    
    public void aplicarPenalidade(int metodoRemocao, int metodoInsercao){
    
        //Learning Automata - Remoções
        for(int i=0; i<LA_remocoes.size(); i++){
            if(metodoRemocao == i){
                double auxValue = (1 - this.penalidade) * LA_remocoes.get(i);
                LA_remocoes.set(i, auxValue);
            }
            else{
                double auxValue = (this.penalidade / (this.LA_remocoes.size() - 1)) + (1 - this.penalidade) * LA_remocoes.get(i);
                LA_remocoes.set(i, auxValue);
            }
        }
        
        //Learning Automata - Inserções
        for(int i=0; i<LA_insercoes.size(); i++){
            if(metodoInsercao == i){
                double auxValue = (1 - this.penalidade) * LA_insercoes.get(i);
                LA_insercoes.set(i, auxValue);
            }
            else{
                double auxValue = (this.penalidade / (this.LA_insercoes.size() - 1)) + (1 - this.penalidade) * LA_insercoes.get(i);
                LA_insercoes.set(i, auxValue);
            }
        }
    }
    
    public int roleta(ArrayList<Double> conj_Prob){
        
        //Roda a roleta!
        double randRoleta = 100 * (this.rand.nextDouble());
        
        //System.out.println("RandRemoção: " + randRoleta);
        double acumulado = 0;
        int metodoEscolhido = 0;
        for(int i=0; i<conj_Prob.size(); i++){
            acumulado += conj_Prob.get(i);
            if(acumulado > randRoleta){
                metodoEscolhido = i;
                break;
            }    
        }
        
        return metodoEscolhido;
    }    
   
    
}
