/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Principal;

import Partes_MOALNSD.Pesos;
import Principal.Solucao;
import java.io.BufferedWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.ArrayList;

/**
 *
 * @author luciano
 */
public class Dominancia {
    
    //Define quem domina entre 2 soluções
    public static int definirDominancia(Solucao sol1, Solucao sol2){
   
        /*** Possibilidades ***/
        // 1) sol1 domina fortemente sol2:             cont1 == 2 e cont2 == 0
        // 2) sol1 domina sol2:                        cont1 == 1 e cont2 == 0
        // 3) sol2 domina fortemente sol1:             cont1 == 0 e cont2 == 2
        // 4) sol2 domina sol2:                        cont1 == 0 e cont2 == 1
        // 5) não existe dominação entre sol1 e sol2:  cont1 == 1 e cont2 == 1
        // 6) sol1 e sol2 tem custos iguais:           cont1 == 0 e cont2 == 0
        
        //Solução 1
        double makespanSol1 = sol1.calcularMakespan();
        double tecSol1 = sol1.calcularTEC();
        int cont1 = 0;
        
        //Solução 2
        double makespanSol2 = sol2.calcularMakespan();
        double tecSol2 = sol2.calcularTEC();
        int cont2 = 0;
        
        //Verificando...
        if(makespanSol1 < makespanSol2)
            cont1++;
        if(tecSol1 < tecSol2)
            cont1++;        
        if(makespanSol2 < makespanSol1)
            cont2++;
        if(tecSol2 < tecSol1)
            cont2++;
        
        //Analisando a dominação...
        if(cont1 > cont2){
            if(cont1 == 2){
                //sol1 domina fortemente sol2
                return 1;    
            }
            else{
                //sol1 domina sol2
                return 2;
            }
        }
        else if(cont2 > cont1){
            if(cont2 == 2){
                //sol2 domina fortemente sol1
                return 3;
            }
            else{
                //sol2 domina sol1
                return 4;
            }
        }
        else{ //Logo (cont1 == cont2)
            if( (cont1 == 1) && (cont2 == 1)){
                //Não existe dominação: cada um ganha em um objetivo
                return 5;
            }
            else{
                //As duas soluções são iguais ((cont1 == 0) && (cont2 == 0))
                return 6;
            }
        }
    }
    
    //Define quem domina entre 2 soluções -> Para a métrica CS
    public static int definirDominancia_CS(FO sol1, FO sol2){
   
        /*** Possibilidades ***/
        // 1) sol1 domina fortemente sol2:             cont1 == 2 e cont2 == 0
        // 2) sol1 domina sol2:                        cont1 == 1 e cont2 == 0
        // 3) sol2 domina fortemente sol1:             cont1 == 0 e cont2 == 2
        // 4) sol2 domina sol2:                        cont1 == 0 e cont2 == 1
        // 5) não existe dominação entre sol1 e sol2:  cont1 == 1 e cont2 == 1
        // 6) sol1 e sol2 tem custos iguais:           cont1 == 0 e cont2 == 0
        
        //Solução 1
        double makespanSol1 = sol1.getCmax();
        double tecSol1 = sol1.getTec();
        int cont1 = 0;
        
        //Solução 2
        double makespanSol2 = sol2.getCmax();
        double tecSol2 = sol2.getTec();
        int cont2 = 0;
        
        //Verificando...
        if(makespanSol1 < makespanSol2)
            cont1++;
        if(tecSol1 < tecSol2)
            cont1++;        
        if(makespanSol2 < makespanSol1)
            cont2++;
        if(tecSol2 < tecSol1)
            cont2++;
        
        //Analisando a dominação...
        if(cont1 > cont2){
            if(cont1 == 2){
                //sol1 domina fortemente sol2
                return 1;    
            }
            else{
                //sol1 domina sol2
                return 2;
            }
        }
        else if(cont2 > cont1){
            if(cont2 == 2){
                //sol2 domina fortemente sol1
                return 3;
            }
            else{
                //sol2 domina sol1
                return 4;
            }
        }
        else{ //Logo (cont1 == cont2)
            if( (cont1 == 1) && (cont2 == 1)){
                //Não existe dominação: cada um ganha em um objetivo
                return 5;
            }
            else{
                //As duas soluções são iguais ((cont1 == 0) && (cont2 == 0))
                return 6;
            }
        }
    }
    
    //Método addSolution de Lust et. al (2010)
    public static ArrayList<Solucao> addSolucao(Instancia instancia, ArrayList<Solucao> D, Solucao sol){
        
        Solucao s = new Solucao(instancia);
        s.clonarSolucoes(sol); 
        
        //Dominancia.imprimirD(D);
        //System.out.println("Solução candidata:");
        //System.out.println("Makespan: " + s.calcularMakespan() + " <=> TEC: " + s.calcularTEC());
    
        boolean add = true;
        int iter = 0;
        
        while(iter < D.size()){
        
            Solucao x = D.get(iter);
            
            // x domina fortemente s ? ou são idênticas ?
            if(Dominancia.definirDominancia(x, s) == 1 || Dominancia.definirDominancia(x, s) == 6){
                add = false;
                break;
            }
            
            // s domina x?
            if( (Dominancia.definirDominancia(s, x) == 1) || (Dominancia.definirDominancia(s, x) == 2) ){
                //Remove x
                D.remove(iter);
                iter = 0;
                
                //System.out.println("Retirou");
                //x.imprimirSolucao();
                //System.out.println("Por conta de");
                //s.imprimirSolucao();
            }
            else{
                iter++;
            }
            
        }
        
        if(add){
            D.add(s);
            //System.out.println("Aceita! - |TAMD "+ D.size());
            //Dominancia.imprimirD(D);
        }
        //else{
        //    System.out.println("Não Aceita! - |TAMD "+ D.size());
        //    Dominancia.imprimirD(D);
        //}
        
        //System.out.println();
        
        return D;
    }
    
}
