/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Principal;

import java.util.ArrayList;

/**
 *
 * @author DecomLuciano
 */

//Classe responsável por armazenar a instância (problema-teste)
public class Instancia {
    
    private String nomeInstancia; //Nome da Instância
    private int numMaqs; //Total de Máquinas
    private int numJobs; //Total de Tarefas
    private int[][] proc; //Tempo de Processamento das Tarefas - Índices: Máquina, Tarefa
    private int[][][] prep; //Tempo de Preparação das Tarefas - Índices: Máquinas, Tarefa, Tarefa
    
    //Novas características
    private int L; //número de velocidades
    private int[] pi; //Potência
    private double[] v; //Fator de Velocidade
    private double[] lambda; //Fator de Potência
    

    public Instancia(int numMaqs, int numJobs, int L) {
        this.numMaqs = numMaqs;
        this.numJobs = numJobs;
        this.L = L;
    }

    public String getNomeInstancia() {
        return nomeInstancia;
    }

    public void setNomeInstancia(String nomeInstancia) {
        this.nomeInstancia = nomeInstancia;
    }
    
    public int getNumMaqs() {
        return numMaqs;
    }

    public void setNumMaqs(int numMaqs) {
        this.numMaqs = numMaqs;
    }

    public int getNumJobs() {
        return numJobs;
    }

    public void setNumJobs(int numJobs) {
        this.numJobs = numJobs;
    }

    public int[][] getProc() {
        return proc;
    }

    public void setProc(int[][] maqs) {
        this.proc = maqs;
    }

    public int[][][] getPrep() {
        return prep;
    }

    public void setPrep(int[][][] setups) {
        this.prep = setups;
    }

    public int getL() {
        return L;
    }

    public void setL(int L) {
        this.L = L;
    }

    public int[] getPi() {
        return pi;
    }

    public void setPi(int[] pi) {
        this.pi = pi;
    }

    public double[] getV() {
        return v;
    }

    public void setV(double[] v) {
        this.v = v;
    }

    public double[] getLambda() {
        return lambda;
    }

    public void setLambda(double[] lambda) {
        this.lambda = lambda;
    }
    
    public void imprimir(){
    
        System.out.println(nomeInstancia);
        
        System.out.println("Máquina + Job = Tempo de Processamento");
        for(int m=0; m < numMaqs; ++m){
            for(int n=0; n < numJobs; ++n){
                System.out.println(m + " + " + n + " = " + proc[m][n]);
            }
        }
        
        System.out.println("Máquina + Tarefa + Tarefa = Tempo de Preparação");
        for(int m=0; m < numMaqs; ++m){
            for(int n=0; n < numJobs; ++n){
                for(int j=0; j < numJobs; ++j){
                    System.out.println(m + " + " + n + " + " + j + " = " + prep[m][n][j]);
                }
            }
        }
        
        System.out.println("Potência");
        for(int l=0; l < numMaqs; ++l){
            System.out.print(pi[l] + " ");
        }
        System.out.println();
        
        System.out.println("Fator de Velocidade");
        for(int l=0; l < L; ++l){
            System.out.print(v[l] + " ");
        }
        System.out.println();
        
        System.out.println("Fator de Potência");
        for(int l=0; l < L; ++l){
            System.out.print(lambda[l] + " ");
        }
        System.out.println();
        
    
    }
    
}
