/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Principal;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

/**
 *
 * @author luciano
 */
public class LeituraArquivo {
    
    private String nomeArquivo;
    private File file;
    private Scanner scanner;
    
    public LeituraArquivo(String nomeArquivo){
        this.nomeArquivo = nomeArquivo;
    }
    
    //Do problema R_m|S_ijk|(C_max,TEC)
    public Instancia readInstance(){
    
        
        //Abrindo arquivo para Leitura
        try{
            file = new File("instancias/" + this.nomeArquivo);
            this.scanner = new Scanner(file);
        }
        catch(FileNotFoundException fileNotFoundException){
            System.err.println("FileNotFoundException.");
            System.exit(1);
        }
        
        //Lixo
        this.scanner.next();
        this.scanner.next();
        this.scanner.next();
        this.scanner.next();
        
        //Número de Máquinas
        String aux_numMaqs = this.scanner.next();
        char []aux_numMaqs_char = aux_numMaqs.toCharArray();
        String aux_numMaqs_string = "";
        for(int i=0; i<aux_numMaqs_char.length-1; i++){
            aux_numMaqs_string = aux_numMaqs_string + aux_numMaqs_char[i]; 
        }
        int numMaqs = new Integer(aux_numMaqs_string);
        
        //Lixo
        this.scanner.next();
        this.scanner.next();
        this.scanner.next();
        
        //Número de Jobs
        String aux_numJobs = this.scanner.next();
        char []aux_numJobs_char = aux_numJobs.toCharArray();
        String aux_numJobs_string = "";
        for(int i=0; i<aux_numJobs_char.length-1; i++){
            aux_numJobs_string = aux_numJobs_string + aux_numJobs_char[i]; 
        }
        int numJobs = new Integer(aux_numJobs_string);
        
        //Lixo
        this.scanner.next();
        this.scanner.next();
        this.scanner.next();
        
        //Número de velocidades  
        ArrayList<Double> list_aux = new ArrayList<Double>();
        while(true){
            String auxiliar = this.scanner.next();
            if(auxiliar.equals(";")){
                break;
            }
            String aux = this.scanner.next();
            list_aux.add(new Double(aux));
        }
        int L = list_aux.size();
        
        //Criando objeto problema
        Instancia instancia = new Instancia(numMaqs, numJobs, L); 
       //System.out.println(numMaqs + " " + numJobs + " " + L);
        
        //Fator de Velocidade
        double []v = new double[L];
        for(int i=0; i<L; i++){
            v[i] = list_aux.get(i);
        }
        instancia.setV(v);
        
        
        this.scanner.next();
        this.scanner.next();
        this.scanner.next();
        
        //Fator de Potência
        double []lambda = new double[L];
        int z = 0;
        while(true){
            String auxiliar = this.scanner.next();
            if(auxiliar.equals(";")){
                break;
            }
            lambda[z++] = new Double(this.scanner.next());
        }
        instancia.setLambda(lambda);
        
        //Lixo
        this.scanner.next();
        this.scanner.next();
        this.scanner.next();
        
        //Potência
        int []pi = new int[numMaqs];
        for(int i=0; i<numMaqs; i++){
            this.scanner.next(); //Lixo
            pi[i] = new Integer(this.scanner.next());
        }
        instancia.setPi(pi);
        
        //Lixo
        this.scanner.next();
        this.scanner.next();
        this.scanner.next();
        this.scanner.next();
        
        //Tempo de processamento
        int[][] proc = new int[numMaqs][numJobs];
        for(int i=0; i < numMaqs; i++){
            for(int j=0; j < numJobs; j++){
                this.scanner.next(); //Lixo
                this.scanner.next(); //Lixo
                proc[i][j] = new Integer(scanner.next());
                //proc[i][j] = proc[i][j] * 10;
                //System.out.println(proc[i][j]);
            }
        }
        instancia.setProc(proc);
        
        //Lixo
        this.scanner.next();
        this.scanner.next();
        this.scanner.next();
        this.scanner.next();
        
        //Tempo de preparação
        int[][][] prep = new int[numMaqs][numJobs][numJobs];
        for(int i=0; i < numMaqs; i++){
            for(int j=0; j < numJobs; j++){
                for(int k=0; k < numJobs; k++){
                    this.scanner.next(); //Lixo
                    this.scanner.next(); //Lixo
                    this.scanner.next(); //Lixo
                    prep[i][j][k] = new Integer(scanner.next());
                    //System.out.println(prep[i][j][k]);
                }    
            }
        }
        instancia.setPrep(prep);
        
        //Nome da instância
        instancia.setNomeInstancia("Instância " + nomeArquivo);
        
        //instancia.imprimir();
        
        return instancia;
        
    }
    
    
}
